# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "deloxide"
version = "1.0.0"
authors = [
    "Emirhan Tala <tala.emirhan@gmail.com>",
    "Ulaş Can Demirbağ <ulascandemirbag@gmail.com>",
]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Deloxide scrubs your threads clean by detecting deadlocks in real time—keeping your system smooth, safe, and corrosion-free. 🦀🧼🔒"
documentation = "https://docs.rs/deloxide"
readme = "README.md"
keywords = [
    "deadlock",
    "concurrency",
    "debug",
    "visualization",
]
categories = [
    "development-tools",
    "concurrency",
    "development-tools::debugging",
    "development-tools::ffi",
]
license = "MIT OR Apache-2.0"
repository = "https://github.com/Emivvvvv/deloxide"

[features]
default = []
lock-order-graph = []
logging-and-visualization = ["dep:crossbeam-channel"]
stress-test = []

[lib]
name = "deloxide"
crate-type = [
    "cdylib",
    "rlib",
    "staticlib",
]
path = "src/lib.rs"

[[bin]]
name = "deloxide"
path = "src/main.rs"
required-features = ["logging-and-visualization"]

[[test]]
name = "condvar_cycle_deadlock"
path = "tests/condvar_cycle_deadlock.rs"

[[test]]
name = "condvar_producer_consumer_deadlock"
path = "tests/condvar_producer_consumer_deadlock.rs"

[[test]]
name = "condvar_spurious_wakeup"
path = "tests/condvar_spurious_wakeup.rs"

[[test]]
name = "dining_philosophers"
path = "tests/dining_philosophers.rs"

[[test]]
name = "five_lock_cycle"
path = "tests/five_lock_cycle.rs"

[[test]]
name = "mixed_rwlock_mutex_condvar_deadlock"
path = "tests/mixed_rwlock_mutex_condvar_deadlock.rs"

[[test]]
name = "mixed_three_thread_deadlock"
path = "tests/mixed_three_thread_deadlock.rs"

[[test]]
name = "mutex_rwlock_deadlock"
path = "tests/mutex_rwlock_deadlock.rs"

[[test]]
name = "random_ring_deadlock"
path = "tests/random_ring_deadlock.rs"

[[test]]
name = "rwlock_deadlock_cycle"
path = "tests/rwlock_deadlock_cycle.rs"

[[test]]
name = "rwlock_multiple_readers_no_deadlock"
path = "tests/rwlock_multiple_readers_no_deadlock.rs"

[[test]]
name = "rwlock_upgrade_deadlock"
path = "tests/rwlock_upgrade_deadlock.rs"

[[test]]
name = "rwlock_writer_waits_for_readers_no_deadlock"
path = "tests/rwlock_writer_waits_for_readers_no_deadlock.rs"

[[test]]
name = "simple_two_thread_deadlock"
path = "tests/simple_two_thread_deadlock.rs"

[dependencies.anyhow]
version = "1.0.99"

[dependencies.base64]
version = "0.22.1"

[dependencies.chrono]
version = "0.4"

[dependencies.clap]
version = "4.5"
features = ["derive"]

[dependencies.crossbeam-channel]
version = "0.5.15"
optional = true

[dependencies.flate2]
version = "1.1"

[dependencies.fxhash]
version = "0.2.1"

[dependencies.lazy_static]
version = "1.5.0"

[dependencies.parking_lot]
version = "0.12.4"

[dependencies.rand]
version = "0.9"

[dependencies.rmp-serde]
version = "1.3.0"

[dependencies.serde]
version = "1.0"
features = ["derive"]

[dependencies.serde_json]
version = "1.0"

[dependencies.tempfile]
version = "3.20"

[dependencies.webbrowser]
version = "1.0.5"
